﻿using System;
using System.Text;
using HeuristicLab.Problems.Instances.TSPLIB;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace UnitTests {
  [TestClass()]
  public class TSPLIBInstanceProviderTest {

    [TestMethod()]
    public void GetTSPLIBTSPInstanceTest() {
      var target = new TSPLIBTSPInstanceProvider();
      StringBuilder erroneousInstances = new StringBuilder();
      int count = 0;
      foreach (var id in target.GetInstanceDescriptors()) {
        try {
          target.GetInstance(id);
        } catch (Exception ex) {
          erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
        }
        count++;
      }
      Assert.IsTrue(count > 0, "No problem instances were found.");
      Assert.IsTrue(erroneousInstances.Length == 0, "Some instances could not be parsed: " + Environment.NewLine + erroneousInstances.ToString());
    }

    [TestMethod()]
    public void GetTSPLIBATSPInstanceTest() {
      var target = new TSPLIBATSPInstanceProvider();
      StringBuilder erroneousInstances = new StringBuilder();
      int count = 0;
      foreach (var id in target.GetInstanceDescriptors()) {
        try {
          target.GetInstance(id);
        } catch (Exception ex) {
          erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
        }
        count++;
      }
      Assert.IsTrue(count > 0, "No problem instances were found.");
      Assert.IsTrue(erroneousInstances.Length == 0, "Some instances could not be parsed: " + Environment.NewLine + erroneousInstances.ToString());
    }

    [TestMethod()]
    public void GetTSPLIBCVRPInstanceTest() {
      var target = new TSPLIBCVRPInstanceProvider();
      StringBuilder erroneousInstances = new StringBuilder();
      int count = 0;
      foreach (var id in target.GetInstanceDescriptors()) {
        try {
          target.GetInstance(id);
        } catch (Exception ex) {
          erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
        }
        count++;
      }
      Assert.IsTrue(count > 0, "No problem instances were found.");
      Assert.IsTrue(erroneousInstances.Length == 0, "Some instances could not be parsed: " + Environment.NewLine + erroneousInstances.ToString());
    }
  }
}
